import * as R from 'ramda';
import isError from 'lodash.iserror';

export const runPlosonOrReject = async ({ ploson, code, createReturn = R.identity }) => {
  const result = await ploson(code);
  return isError(result) ? Promise.reject(result) : createReturn(result);
};

export const groupByHasCallback = R.groupBy(({ callback }) =>
  callback ? 'updatedSoft' : 'updatedHard',
);

export const populateCallbacks = R.map(({ trigger, ploson, ...item }) =>
  runPlosonOrReject({
    ploson,
    code: trigger,
    createReturn: (callback) => ({ ...item, trigger, ploson, callback }),
  }),
);

export const getTriggerCallbackActor = (callback, targets) => (sendCb) =>
  callback((payload, dynamicTargets) => {
    // console.log('payload:', payload);
    return sendCb({ type: 'FIRE_RULES', targets: dynamicTargets ?? targets, payload });
  });
