import{assign as e,createMachine as r,send as t,spawn as o,actions as i,interpret as n}from"xstate";import{OBJ as a,ARR as s,createRunner as d,FUNC as c}from"ploson";import*as l from"ramda";import p from"joi";import{createPatch as g}from"rfc6902";import u from"lodash.isfunction";import{isBefore as f}from"date-fns/fp/index.js";import E from"lodash.iserror";const m=p.object().unknown().keys({id:p.string().required().description("Identifier for this particular rule."),active:p.boolean().default(!0).description("If the rule is active or not. An inactive rule is not run at all."),ttl:p.date().default(0xfd4fff4e446).description("At this time (ISO timestamp) the rule will be set to inactive."),onLoad:p.any().description("Ploson code to e.g. create reusable constants and functions."),cooldown:p.number().min(0).description("A rule can't be triggered again unless this number of seconds has passed."),resetCondition:p.any().description("Ploson code to check if rule should reset, if it is in flipped state."),resetAction:p.any().description("Ploson code block to execute when resetCondition is true."),condition:p.any().default(!0).description("Ploson code to check if rule should execute (state to flipped, run actions etc)."),action:p.any().description("Ploson code block to execute when condition is true (& not in flipped state).")}),v=e=>{const{value:r,error:t,warning:o}=m.validate(e);return o&&console.warn(o),t?[Error(t)]:[void 0,r]},R=l.differenceWith(({id:e}=a,{id:r}=a)=>e===r),T=({idKey:e="id",ignoreKeys:r,skipIf:t,autoRemoveCondition:o,transformAutoRemoved:i,transformAdded:n,transformUpdated:a}={})=>s=>l.converge(l.mergeLeft,[l.reduce((i,d)=>{if(t&&t(d))return i;if(o&&o(d))return i;const{[e]:c}=d,p=l.find(l.propEq("id",c))(s);if(p){const e=l.when(()=>r,l.map(l.omit(r)))([p,d]),t=g(...e);return l.isEmpty(t)?i:{...i,updated:[...i.updated,a?a(d,p,t):d]}}return{...i,added:[...i.added,n?n(d):d]}},{added:[],updated:[]}),l.pipe(l.converge(l.concat,[R(s),l.pipe(l.filter(o??l.F),l.map(r=>{const{[e]:t}=r,o=l.find(l.propEq("id",t))(s);return i?i(r,o):r}))]),l.objOf("removed"))]),h=function({ploson:e,code:r,createReturn:t=l.identity}){try{return Promise.resolve(e(r)).then(function(e){return E(e)?Promise.reject(e):t(e)})}catch(e){return Promise.reject(e)}},y=l.groupBy(({callback:e})=>e?"updatedSoft":"updatedHard"),A=l.map(({trigger:e,ploson:r,...t})=>h({ploson:r,code:e,createReturn:o=>({...t,trigger:e,ploson:r,callback:o})})),P=(e,r)=>t=>e((e,o)=>t({type:"FIRE_RULES",targets:o??r,payload:e})),k={delays:{COOLDOWN:({cooldown:e})=>e},guards:{hasCooldown:({cooldown:e})=>Boolean(e),hasHysteresis:({resetCondition:e})=>Boolean(e),conditionTruthy:(e,{data:[r]=s})=>Boolean(r),isExpired:({ttl:e})=>f(new Date)(e)},services:{checkIfExpired:({ttl:e},{payload:r})=>f(new Date)(e)?Promise.reject(Error("Take onError path")):Promise.resolve({payload:r}),condition:({condition:e,ploson:r},{data:{payload:t}})=>h({ploson:r,payload:t,code:[",",{payload:Promise.resolve(t)},e],createReturn:e=>[e,t]}),resetCondition:({resetCondition:e,ploson:r},{payload:t})=>h({ploson:r,payload:t,code:[",",{payload:Promise.resolve(t)},e],createReturn:e=>[e,t]}),action:function({action:e,ploson:r},{data:[,t]=s}){try{return Promise.resolve(h({ploson:r,payload:t,code:[",",{payload:Promise.resolve(t)},e]}))}catch(e){return Promise.reject(e)}},resetAction:({resetAction:e,ploson:r},{data:[,t]=s})=>h({ploson:r,payload:t,code:[",",{payload:Promise.resolve(t)},e]})},actions:{log:()=>console.log("Inactivation GOTTEN!"),logError:(e,{data:r})=>console.error(r),updateRule:e({ttl:(e,{rule:{ttl:r}=a})=>r,hysteresis:(e,{rule:{hysteresis:r}=a})=>r,condition:(e,{rule:{condition:r}=a})=>r,action:(e,{rule:{action:r}=a})=>r,cooldown:(e,{rule:{cooldown:r}=a})=>r,resetCondition:(e,{rule:{resetCondition:r}=a})=>r,resetAction:(e,{rule:{resetAction:r}=a})=>r})}},D=r({predictableActionArguments:!0,id:"rule",initial:"idle",on:{INACTIVATE:{actions:"log",target:"inactive"},UPDATE:{actions:"updateRule"}},states:{inactive:{on:{ACTIVATE:"idle"}},idle:{on:{FIRE:"checkExpired"}},checkExpired:{invoke:{src:"checkIfExpired",onDone:"checkCondition",onError:"expired"}},checkCondition:{invoke:{src:"condition",onDone:[{cond:"conditionTruthy",target:"executeAction"},{target:"idle"}],onError:{actions:"logError",target:"idle"}}},executeAction:{invoke:{src:"action",onDone:{target:"fired"},onError:{actions:"logError",target:"fired"}}},fired:{type:"parallel",on:{ABORT:"idle"},states:{switcher:{initial:"decide",states:{decide:{always:[{cond:"hasHysteresis",target:"flipped"},{target:"done"}]},flipped:{on:{FIRE:"checkCondition"}},checkCondition:{invoke:{src:"resetCondition",onDone:[{cond:"conditionTruthy",target:"executeResetAction"},{target:"flipped"}],onError:{actions:"logError",target:"executeResetAction"}}},executeResetAction:{invoke:{src:"resetAction",onDone:{target:"done"},onError:{actions:"logError",target:"done"}}},done:{type:"final"}}},temperature:{initial:"decide",states:{decide:{always:[{cond:"hasCooldown",target:"hot"},{target:"cool"}]},hot:{after:{COOLDOWN:"cool"}},cool:{type:"final"}}}},onDone:"idle"},expired:{type:"final"}}},k),U=p.object().unknown().keys({id:p.string().required().description("Identifier for this particular trigger."),active:p.boolean().default(!0).description("If the trigger is active or not. An inactive trigger is not run at all."),trigger:p.array().required().items(p.any()).description("Ploson function representing a callback actor."),targets:p.array().items(p.string()).unique().description("List of rule IDs that this trigger should trigger.")}),I=e=>{const{value:r,error:t,warning:o}=U.validate(e);return o&&console.warn(o),t?[Error(t)]:[void 0,r]},{stop:x}=i,w=function({rules:e},{data:r}){try{const[t,o]=v(r);if(t)return Promise.reject(t);const i=l.find(l.propEq("id",o.id))(e),{ref:n,ploson:a,...s}=i,d=g(s,o);return Promise.resolve({...o,ploson:a,ref:n,lastPatch:d})}catch(e){return Promise.reject(e)}},b=({rules:r},{data:o})=>{const{id:i,lastPatch:n,ref:a,active:s}=o,d=l.findIndex(l.propEq("id",i),r),c=l.any(l.pipe(l.prop("path"),l.startsWith("/condition")))(n),p=l.pipe(l.find(l.propEq("path","/active")),l.propEq("value",!0))(n);return[e({rules:l.update(d,o)(r)}),t({type:"UPDATE",rule:o},{to:a}),...s?[]:[t("INACTIVATE",{to:a})],...c?[t("ABORT",{to:a})]:[],...p?[t("ACTIVATE",{to:a})]:[]]},L=({id:e,active:r,...t})=>{console.info("Spawning Rule with id:",e);const i=r?{ref:o(D.withContext(t),e)}:{};return{id:e,active:r,...t,...i}},q=function({triggers:e},{data:r}){try{function t(e){return e&&!u(e)?Promise.reject(Error("trigger is not a function")):{...i,ploson:p,callback:c,ref:f,...R?{callback:e}:{},doUpdateTrigger:R}}const[o,i]=I(r);if(o)return Promise.reject(o);const{id:n,trigger:a,active:s}=i,d=l.find(l.propEq("id",n))(e),{callback:c,ploson:p,ref:f,doUpdateTrigger:E,...m}=d,v=g(m,i),R=l.pipe(l.find(l.propEq("path","/active")),l.propEq("value",!0))(v)||s&&l.any(l.propEq("path","/trigger"))(v);return Promise.resolve(R?Promise.resolve(h({ploson:p,code:a})).then(t):t(R))}catch(T){return Promise.reject(T)}},C=({active:e,callback:r,targets:t,id:i,...n})=>(console.info("Spawning Trigger with id:",i),{id:i,active:e,targets:t,callback:r,...n,...e?{ref:o(P(r,t),i)}:{}}),_=({triggers:r},{data:t})=>{const{id:i,doUpdateTrigger:n,callback:a,ref:s,targets:d,active:c}=t,p=l.findIndex(l.propEq("id",i),r);return[...n||!c&&s?[x(s)]:[],...n?[o(P(a,d),i)]:[],e({triggers:l.update(p,t)(r)})]},{pure:j,stop:G}=i,S={ADD_RULE:{actions:"defer"},ADD_TRIGGER:{actions:"defer"},UPDATE_RULE:{actions:"defer"},UPDATE_TRIGGER:{actions:"defer"},DELETE_RULE:{actions:"defer"},DELETE_TRIGGER:{actions:"defer"}},F={predictableActionArguments:!0,id:"rule-manager",initial:"initRules",context:{$queue:[],rules:[],triggers:[]},states:{retryRules:{after:{RETRY_DELAY:{target:"initRules"}}},initRules:{invoke:{src:"ruleFetcher",onDone:"prepareRules",onError:{actions:"logError",target:"retryRules"}}},prepareRules:{invoke:{id:"processInitRules",src:"processRules",onDone:{actions:"addRules",target:"initTriggers"},onError:{actions:"logError",target:"initTriggers"}}},retryTriggers:{after:{RETRY_DELAY:{target:"initTriggers"}}},initTriggers:{invoke:{src:"triggerFetcher",onDone:{target:"prepareTriggers"},onError:{actions:"logError",target:"retryTriggers"}}},prepareTriggers:{invoke:{id:"processInitTriggers",src:"processTriggers",onDone:{actions:["addTriggers"],target:"running"},onError:{actions:"logError",target:"running"}}},running:{entry:"spawnUpdater",initial:"idle",on:{FIRE_RULES:{actions:"fireRules"}},states:{idle:{entry:"recallFromQueue",on:{UPDATE_RULES:{target:"updatingRules"},UPDATE_TRIGGERS:{target:"processingTriggers"},ADD_RULE:{target:"prepareAddingRule"},ADD_TRIGGER:{target:"prepareAddingTrigger"},UPDATE_RULE:{target:"prepareUpdatingRule"},UPDATE_TRIGGER:{target:"prepareUpdatingTrigger"},DELETE_RULE:{actions:"removeRule"},DELETE_TRIGGER:{actions:"removeTrigger"}}},prepareAddingRule:{invoke:{src:"prepareAddedRule",onError:{actions:"logError",target:"idle"},onDone:{actions:"addRuleExternal",target:"idle"}},on:S},prepareAddingTrigger:{invoke:{src:"prepareAddedTrigger",onError:{actions:"logError",target:"idle"},onDone:{actions:"addTriggerExternal",target:"idle"}},on:S},prepareUpdatingRule:{invoke:{src:"prepareUpdatedRule",onError:{actions:"logError",target:"idle"},onDone:{actions:"updateRuleExternal",target:"idle"}},on:S},prepareUpdatingTrigger:{invoke:{src:"prepareUpdatedTrigger",onError:{actions:"logError",target:"idle"},onDone:{actions:"updateTriggerExternal",target:"idle"}},on:S},updatingRules:{invoke:{id:"processRuleUpdates",src:"processRules",onDone:{actions:["removeRules","addRules","updateRules"],target:"idle"},onError:{actions:"logError",target:"idle"}}},processingTriggers:{invoke:{id:"processTriggerUpdates",src:"processTriggers",onDone:{actions:["killActors","sendUpdateTriggers"]},onError:{actions:"logError",target:"idle"}},on:{PASS_ON_RESULT:"updatingTriggers"}},updatingTriggers:{entry:["removeTriggers","updateTriggers","addTriggers"],always:{target:"idle"}}}}}},O=i=>r(F,(({ruleFetcher:r=(()=>Promise.resolve(s)),triggerFetcher:i=(()=>Promise.resolve(s)),staticEnv:n=a,staticEnvTriggers:p=n,updater:g=c})=>{const f=T({ignoreKeys:["ref","ploson","active"],autoRemoveCondition:({active:e})=>!e,transformAdded:e=>{const{value:r,error:t,warning:o}=m.validate(e);return(t||o)&&console.warn(t||o),{...r,ploson:d({staticEnv:n})}},transformUpdated:(e,{ploson:r,ref:t})=>({...e,ploson:r,ref:t})}),E=T({ignoreKeys:["ploson","callback","ref"],autoRemoveCondition:({active:e})=>!e,transformAutoRemoved:(e,{ref:r})=>({...e,ref:r}),transformAdded:({targets:e=s,...r})=>({...r,targets:e,ploson:d({staticEnv:p})}),transformUpdated:(e,{ploson:r,callback:t,ref:o},i)=>({...e,ploson:r,ref:o,...l.any(l.propEq("path","/trigger"))(i)||!e.active?a:{callback:t}})}),P=(e=>function(r,{data:t}){try{function o(){return{...n,ploson:a}}const[i,n]=v(t);if(i)return Promise.reject(i);const a=d({staticEnv:e}),{onLoad:s}=t,c=function(){if(s)return Promise.resolve(h({ploson:a,code:s})).then(function(){})}();return Promise.resolve(c&&c.then?c.then(o):o())}catch(l){return Promise.reject(l)}})(n),k=(e=>function(r,{data:t}){try{const[r,o]=I(t);if(r)return Promise.reject(r);const{trigger:i,...n}=o,a=d({staticEnv:e});return Promise.resolve(h({ploson:a,code:i})).then(function(e){return u(e)?{...n,trigger:i,ploson:a,callback:e}:Promise.reject(Error("trigger is not a function"))})}catch(e){return Promise.reject(e)}})(p);return{delays:{RETRY_DELAY:3e4},services:{ruleFetcher:r,triggerFetcher:i,processRules:function({rules:e},{data:r=s}){try{const{added:t,updated:o,removed:i}=f(e)(r);return Promise.resolve(Promise.all(l.map(({onLoad:e,ploson:r})=>e?h({ploson:r,code:e}):Promise.resolve())(t))).then(function(){return{added:t,toRemove:i,toUpdate:o}})}catch(e){return Promise.reject(e)}},processTriggers:function({triggers:e},{data:r=s}){try{const{added:t,updated:o,removed:i}=E(e)(r),{updatedHard:n=s,updatedSoft:a=s}=y(o);return Promise.resolve(Promise.all(A([...t,...n]))).then(function(e){return{added:e,toRemove:i,toUpdate:a,toRestart:n}})}catch(e){return Promise.reject(e)}},prepareAddedRule:P,prepareAddedTrigger:k,prepareUpdatedRule:w,prepareUpdatedTrigger:q},actions:{defer:e({$queue:({$queue:e},r)=>l.append(r,e)}),recallFromQueue:j(({$queue:[r,...o]})=>[...r?[t(r)]:[],e({$queue:o})]),addRuleExternal:e({rules:({rules:e},{data:r})=>l.append(L(r))(e)}),removeRule:j(({rules:r},{data:{id:t}=a})=>{const o=l.findIndex(l.propEq("id",t),r);if(-1===o)return[];const{ref:i}=r[o];return[G(i),e({rules:l.remove(o,1)(r)})]}),addTriggerExternal:e({triggers:({triggers:e},{data:r})=>l.append(C(r))(e)}),removeTrigger:j(({triggers:r},{data:{id:t}=a})=>{const o=l.findIndex(l.propEq("id",t),r);if(-1===o)return[];const{ref:i}=r[o];return[G(i),e({triggers:l.remove(o,1)(r)})]}),updateRuleExternal:j(b),updateTriggerExternal:j(_),logError:(e,{data:r})=>console.error(r),killActors:j((e,{data:{toRemove:r=s,toRestart:t=s}=a})=>l.pipe(l.filter(({ref:e})=>Boolean(e)),l.map(({ref:e})=>G(e)))([...r,...t])),sendUpdateTriggers:t((e,{data:r})=>({type:"PASS_ON_RESULT",data:r})),removeTriggers:e({triggers:({triggers:e},{data:{toRemove:r=s}=a})=>R(e,r)}),addTriggers:e({triggers:({triggers:e},{data:{added:r=s,toRestart:t=s}=a})=>[...e,...l.map(C)([...r,...t])]}),updateTriggers:e({triggers:({triggers:e},{data:{toUpdate:r=s}=a})=>l.map(e=>{const t=l.find(l.propEq("id",e.id))(r);return t?l.assoc("targets",t.targets??[],e):e})(e)}),removeRules:e({rules:({rules:e},{data:{toRemove:r=s}=a})=>R(e,r)}),addRules:e({rules:({rules:e},{data:{added:r=s}=a})=>[...e,...l.map(L)(r)]}),updateRules:j((e,{data:{toUpdate:r=s}=a})=>l.map(e=>t({type:"UPDATE_RULE",data:e}))(r)),fireRules:j(({rules:e},{targets:r,payload:o})=>l.reduce((e,{id:i,active:n,ref:a})=>n&&a&&l.includes(i,r)?[...e,t({type:"FIRE",payload:o},{to:a})]:e,[])(e)),spawnUpdater:e({updaterRef:()=>o(g,"rule-trigger-updater")})}}})(i)),B=function(){return n(O(...[].slice.call(arguments)))};export{m as Rule,B as createRuleEngine,O as createRuleEngineMachine};
//# sourceMappingURL=ploson-rule-engine.module.mjs.map
